import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;

public class AADconfigPanel extends JPanel {

String[] conf; 
String[] params;
JTextField[] s;
ActionListener[] al;
JPanel[] pp;
int n;
String WebServerFileName;
desktop d;
String selectedServer;

  public AADconfigPanel(desktop d, String selectedServer) {

  this.d = d;
  this.selectedServer = selectedServer;
  n = d.n_AAD;
  
  conf = new String[n];
  for(int i=0;i<n;i++) {
     conf[i]="";
  }
  s = new JTextField[n];
  params = new String[n];
  params[0]=" AAD root directory ";
  params[1]="       AAD.dtd file ";
  params[2]="       AAD.xml file ";

  pp = new JPanel[n];
  al = new ActionListener[n];
  
  WebServerFileName = selectedServer+"AAD.conf";

  File conffile = new File(WebServerFileName);
  if(conffile.exists()) {
    try {
      FileReader fr = new FileReader(conffile);
      BufferedReader in = new BufferedReader(fr);
      String nextline = in.readLine();
      in.close();
      StringTokenizer st = new StringTokenizer(nextline,"+");
      for(int i=0; i<n; i++) {
        conf[i] = st.nextToken();
      }
      d.setAADConfig(conf);
   }
    catch (Exception e) {System.out.println(e);}
  }  
  else {
    System.out.println("new configuration");
  }


  setLayout(new BorderLayout());

  JPanel ss = new JPanel();
  ss.setLayout(new GridLayout(n,1));


     al[0] = new ActionListener() {
        public void actionPerformed(ActionEvent e) {
        setAADconf(0,e.getActionCommand());
     }
     };

     al[1] = new ActionListener() {
        public void actionPerformed(ActionEvent e) {
        setAADconf(1,e.getActionCommand());
     }
     };
     al[2] = new ActionListener() {
        public void actionPerformed(ActionEvent e) {
        setAADconf(2,e.getActionCommand());
     }
     };
  if(n>3) {
     System.out.println("not enough action listeners in WebServerPanel");
     System.exit(0);
  }

  conf[0]=d.WS_docroot+"/DESCRIPTORS/APPLICATION/";
  conf[1]=conf[0]+"ApplDescV2.dtd";
  conf[2]=conf[0]+"AAD.xml";
   
  JLabel l;
  for (int i = 0; i<n; i++) {
     pp[i] = new JPanel();
     pp[i].setLayout(new BorderLayout());
     l = new JLabel(params[i]);
     l.setFont(new Font("Courier", Font.BOLD, 12));
     l.setForeground(Color.black);
     pp[i].add(l,BorderLayout.WEST);
     s[i] = new JTextField(conf[i],25);
     s[i].setPreferredSize(new Dimension(100,5));
     s[i].addActionListener(al[i]);
     pp[i].add(s[i],BorderLayout.CENTER);
     ss.add(pp[i]);  
  }
  
  add(ss,BorderLayout.CENTER);
  
  JPanel bp = new JPanel();
  bp.setLayout(new GridLayout(1,2));
  JButton b1 = new JButton("Commit");
  b1.addActionListener(new ActionListener() {
    public void actionPerformed(ActionEvent e) {
       commit();
    }
  });
  bp.add(b1);

  JButton b2 = new JButton("Reset");
  b2.addActionListener(new ActionListener() {
    public void actionPerformed(ActionEvent e) {
       reset();
    }
  });
  bp.add(b2);
  add(bp,BorderLayout.SOUTH);
  }


  public void setAADconf(int i, String h) {
     conf[i]=h;
  } 

  public void commit() {
     d.setAADConfig(conf);
     try {    
        FileWriter fw = new FileWriter(WebServerFileName);
        for (int i=0;i<n;i++) {
          if(conf[i].length()<1) fw.write("null+"); 
          else fw.write(conf[i]+"+");
        }
        fw.flush();
        fw.close();
     }
     catch (Exception e) { System.out.println(e);}
  }

  public void reset() {
    for(int i=0;i<n;i++) {
     conf[i]="";
     s[i].setText("");
    }
  }

}


