import WebFlow.*;
import WebFlow.event.*;
import WebFlow.xml.*;
import WebFlow.submitJob.*;
import WebFlow.ATD.*;
import org.omg.CORBA.*;
import java.io.*;
import java.net.*;
import java.util.*;

public class CRPCclient {

ORB orb;
String IorURL;
WebFlowContext master;

  public CRPCclient(String IorURL) {
    this.IorURL = IorURL;
  }

  public void Client(String XmlInput) {
    WebFlowContext wfc;

    System.out.println("CRPC"); 

    initializeORB();
    master = getMasterServer();
    if(master==null) {
      System.out.println("Cannot connect to the master server");
    }
    else {
	/* add XMLserver module */

        org.omg.CORBA.Object oxml = master.addNewModule("XmlServer");
        XmlServer parser = XmlServerHelper.narrow(oxml);
        parser.test();

        /* add submitJob module */
        org.omg.CORBA.Object osj = master.addNewModule("submitJob");
        submitJob submit = submitJobHelper.narrow(osj);
        submit.test(); 

       
       if (parser.instantiateParser(XmlInput)) {
           String[] iHosts=parser.getInstalledHosts();

        ATDFrame app = new ATDFrame(iHosts);

	while (!app.retstatus()) {
          // System.out.println("looping......");
              waitFor(1000);
	}                 

        if (app.framewb){
	   String HostName = app.HName;

	   System.out.println("the selected host is :..." +HostName);
	   String[] inputfiles = parser.GetIPFiles(HostName);
	   System.out.println("got the input files.......");
	   String[] outfiles = parser.GetOPFiles(HostName);
	   System.out.println("got the output files.......");
	                     
	   for(int i=0; i<(inputfiles.length); i=i+2){
	        framew frm=new framew(i+1, inputfiles.length, 
                inputfiles[i],inputfiles[i+1]);
                frm.show();
		String[] sdata=new String [3];
		while(frm.quit()){
		  // System.out.println("waiting for status to change.....");
		  while(!frm.getStatus()){ }
			if (frm.getStatus()){
			sdata[0]=frm.tone.getText();
			sdata[1]=frm.ttwo.getText();
			sdata[2]=frm.tthree.getText();
			parser.AddIPSource(sdata);
			frm.resetStatus();
			}
			frm.inprog=false;
		}
	       
	   }
	
		
           for(int i=0; i<outfiles.length; i=i+2){
               framew frm=new framew(i+1, outfiles.length, outfiles[i],
                        outfiles[i+1]);
                String[] sodata=new String [3];
                while(frm.quit()){
                       while(!frm.getStatus()){ }
                       if (frm.getStatus()) {
                        sodata[0]=frm.tone.getText();
                        sodata[1]=frm.ttwo.getText();
                        sodata[2]=frm.tthree.getText();
                        parser.GetOPSource(sodata);
                        frm.resetStatus();
                        }
                        frm.inprog=false;
                }
	      
	   }

           String temp = parser.createAD(HostName);
	   String opfname = parser.SaveAsXml();
	   System.out.println("got the file name........" +opfname); 
	   parser.descriptorGD(opfname);
	}
       }
       else {
         System.out.println("XmlServer failed");
       }

        master.removeModule(oxml);
        master.removeModule(osj);
        System.out.println("test completed");
    }
  }

  public void initializeORB() { 
   Properties props = System.getProperties();
   props.put("org.omg.CORBA.ORBClass", "com.ooc.CORBA.ORB");
   props.put("org.omg.CORBA.ORBSingletonClass", "com.ooc.CORBA.ORBSingleton");
   System.setProperties(props);
   String[] args = new String[1];
   args[0]=IorURL;
   orb = ORB.init(args, props);
  }

  public WebFlowContext getMasterServer(){
    WebFlowContext ws = null;
    try {
      String masterIOR = getIORFromURL(IorURL);
      org.omg.CORBA.Object o = orb.string_to_object(masterIOR);
      
      ws = WebFlowContextHelper.narrow(o);
    }
    catch (Exception e) {System.out.println("getMasterServer: "+e);}
    return ws;
  }

  public String getIORFromURL(String urlString){
    String masterServerIOR="";
    String thisLine=null;
      try {
        URL u = new URL(urlString);
        try {
          DataInputStream theHTML = new DataInputStream(u.openStream());
          try {
            while ((thisLine = theHTML.readLine()) != null) {
		  masterServerIOR += thisLine;
            } 
          } 
          catch (Exception e) {
            System.out.println("getIORfromURL:"+e);
          }
        } 
        catch (Exception e) {
          System.out.println("getIORfromURL:"+e);
        }

      } 
      catch (MalformedURLException e) {
        System.out.println("getIORfromURL:"+urlString + " is not a parseable URL");
        System.out.println("getIORfromURL:"+e);
      }
    return masterServerIOR;
  }

   public synchronized void waitFor(long howLong){
     try {
        wait(howLong);
     } catch (Exception e) { System.out.println(e);}
   }

}






