import WebFlow.*;
import WebFlow.event.*;
import WebFlow.xml.*;
import WebFlow.submitJob.*;
import WebFlow.ATD.*;
import org.omg.CORBA.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;
import java.util.*;
import javax.swing.plaf.metal.*;

public class RunAppl extends JInternalFrame{

public String[] hostList;
String selectedServer;
desktop d;
JComboBox cb, acb;
Vector hosts;
JTabbedPane inputs,outputs;
String application;
public String ApplHost;
JPanel[] inTab, outTab;
JTextField[] inTextField, outTextField;
JTextArea cmdDisplay;
int cmdDisplayLength=180;
String Applications[];
String xmlFile;
JPanel helpPanel, optionPanel, streamPanel, argPanel, envPanel;
JPanel SwPanel, ArPanel;
MetalLookAndFeel metalLF = new MetalLookAndFeel();

ORB orb;
String IorURL;
WebFlowContext master;
submitJob submit;
XmlServer parser;


  public  RunAppl(desktop d) {
  super("Run Application", true, true, true, true);
  this.d = d;
  IorURL = d.IORfileURL;
  
  this.selectedServer = d.selectedServer;
  xmlFile = d.AADxml;
  connect();

  JPanel bck = new JPanel();
  bck.setLayout(new BorderLayout());
  getContentPane().add(bck);
  

  JPanel upper = new JPanel();
  JTabbedPane center = new JTabbedPane();
  JPanel lower = new JPanel();


  /* ----- upper panel ----- */
  upper.setLayout(new GridLayout(3,1));

  JPanel applPanel = new JPanel();
  JPanel hostPanel = new JPanel();
  JPanel cmdPanel = new JPanel();

  /* applPanel */

  applPanel.setLayout(new GridLayout(1,2)); 
  applPanel.add(new JLabel("select application: "));
  acb = new JComboBox();
  acb.setPreferredSize(new Dimension(200,20));
  applicationList();
  acb.addActionListener(new ActionListener(){
    public void actionPerformed(ActionEvent e) {
       setApplication((String)((JComboBox)e.getSource()).getSelectedItem());
    }
  });
  applPanel.add(acb);

  /* host panel */
  hostPanel.setLayout(new GridLayout(1,2)); 
  hostPanel.add(new JLabel("select target host: "));
  hosts=new Vector();
  cb = new JComboBox(hosts);
  cb.setPreferredSize(new Dimension(200,20));
  cb.addActionListener(new ActionListener(){
    public void actionPerformed(ActionEvent e) {
       setApplHost((String)((JComboBox)e.getSource()).getSelectedItem());
    }
  });
  hostPanel.add(cb);

  /* cmdPanel */
  cmdDisplay = new JTextArea();
  //cmdDisplay = new JTextArea("command line goes here",cmdDisplayLength,5);
  cmdDisplay.setEditable(false);
  cmdDisplay.setPreferredSize(new Dimension(cmdDisplayLength*3,20));
  cmdPanel.add(cmdDisplay);
  //cmdPanel.add(new JLabel("command goes here"));

    upper.add(applPanel); 
    upper.add(hostPanel);
    upper.add(cmdPanel);

  /*-----  end of upper pannel -----*/

  /*------ center panel ------------*/
  helpPanel = new JPanel();
  helpPanel.add(new JLabel("Help"));
  optionPanel = new JPanel();
  optionPanel.setLayout(new BorderLayout());
  optionPanel.add(new JLabel("select switches"),BorderLayout.NORTH);
  argPanel = new JPanel();
  argPanel.setLayout(new BorderLayout());
  argPanel.add(new JLabel("set arguments"),BorderLayout.NORTH);
  JPanel inPanel = new JPanel();
  JPanel outPanel = new JPanel();
  streamPanel = new JPanel();
  streamPanel.add(new JLabel("redirect streams"));
  envPanel = new JPanel();
  envPanel.add(new JLabel("set environmental variables"));

  /* inPanel */
  inputs = new JTabbedPane();
  inPanel.add(inputs);

  /* outPanel */ 

  outputs = new JTabbedPane(); 
  outPanel.add(outputs);

  center.addTab("Help",helpPanel);
  center.addTab("options",optionPanel);
  center.addTab("arguments",argPanel);
  center.addTab("inputFiles",inPanel);
  center.addTab("outputFiles",outPanel);
  center.addTab("streams",streamPanel);
  center.addTab("environment",envPanel);

  /* ----- end of center panel ------*/
  
  /* ------ lower panel -------------*/
  JButton runB = new JButton("submit job");
  runB.addActionListener(new ActionListener() {
       public void actionPerformed(ActionEvent e) {
         submitJob();
       }
     });
  lower.add(runB);
  /* ------ end of lower panel--------*/

  bck.add(upper, BorderLayout.NORTH);
  bck.add(center, BorderLayout.CENTER);
  bck.add(lower, BorderLayout.SOUTH);

  setFrameIcon( new ImageIcon ("gifIcon.gif"));
  
  try{
      UIManager.setLookAndFeel(metalLF);
      }
      catch (Exception ex) {
      System.out.println(ex);
      }
      
      UIManager.put("InternalFrameTitlePane.closeIcon", new ImageIcon("gifIcon.gif"));
     
  }

  public void submitJob() {
      System.out.println("job submitted");
    }

  public void applicationList() {
    System.out.println("try to instantiate parser with "+xmlFile);
    if(parser.instantiateParser(xmlFile)) {
       Applications=parser.getApplications();
    }
    for(int i=0; i<Applications.length; i++) {
       acb.addItem(Applications[i]);
    }
    acb.setSelectedIndex(0);
  } 

  public void setApplication(String s){
    application = s;
    updateHosts();
  } 

  public void setApplHost(String s){
    String cmd,cmdLine;
    ApplHost = s;
    System.out.println("Selected host: "+ApplHost);
    System.out.println(xmlFile);
    System.out.println(application);
    if(parser.instantiateParser(xmlFile)) {
      String exec = parser.getExec(application,ApplHost);
      String[] arguments = parser.getArguments(application,ApplHost); 
      String[] switches = parser.getSwitches(application,ApplHost);
      String[] NameValue = parser.getNameValue(application,ApplHost);
      cmdLine = exec;
      if(!switches[0].equals("null")) {
        int nSwitches = switches.length;
        if(SwPanel != null) SwPanel.removeAll();
        else SwPanel = new JPanel();
        if(nSwitches < 7) {
           SwPanel.setLayout(new GridLayout(0,2));
	}
        else {
           SwPanel.setLayout(new GridLayout((nSwitches+1)/2,4));
	}
        String thisSwitch,thisValue,thisSpace,thisMult;  
        boolean msfixed,mfixed,literal,v;
        for(int i=0; i<nSwitches; i++) {
          thisSwitch="";
          thisValue="";
          thisSpace="";
          thisMult="";
          msfixed=false;
          mfixed=false;
          v=false;
          literal=false;
          System.out.println(switches[i]);
          StringTokenizer st = new StringTokenizer(switches[i]);
          System.out.println("Tokenizer="+st);
          while(st.hasMoreTokens()) {
           String nextToken = st.nextToken();
           int l = nextToken.length();
           if(nextToken.equals("[msfixed]")) msfixed=true;
           else {
            if(nextToken.equals("[msquestion]")) msfixed=false;
            else { 
             if (nextToken.equals("[mfixed]")) mfixed=true;
             else {
	      if(nextToken.startsWith("[m")) {
                thisMult=nextToken.substring(2,l-2);
	      }
     	      else {
		if(nextToken.startsWith("[s")) {
                 if(nextToken.indexOf("none")>-1) thisSpace=""; 
                 if(nextToken.indexOf("space")>-1) thisSpace=" "; 
                 if(nextToken.indexOf("equals")>-1) thisSpace="="; 
                }
		 else {
                   if(nextToken.startsWith("[v")) {
                      thisValue = nextToken.substring(2,l-2);
                      v=true; 
		   }
		   else {
                     if(nextToken.startsWith("[t")) {
                        if(nextToken.equals("[tliteral]")) literal=true;
		     }
                     else {
                       thisSwitch = nextToken;
		     }
		   }
		 }
	      }
	     }
	    }
	   }
	  } //while

	  if(msfixed) {
             cmdLine += " "+thisSwitch;
             if(v) cmdLine += thisSpace+thisValue;
	  } 
          else {
            JCheckBox cb = new JCheckBox(thisSwitch);
            cb.addItemListener(new ItemListener() {
	      public void itemStateChanged(ItemEvent ev) {
              JCheckBox src=(JCheckBox)ev.getSource();
              String what=src.getText();
              checkBoxChange(ev.getStateChange(),what);
	      }
	    });
            SwPanel.add(cb);
            if(v) {
              if(literal){
                SwPanel.add(new JLabel(thisValue));
	      }
              else {
                JTextField tf = new JTextField();
                tf.setPreferredSize(new Dimension(150,15));
                SwPanel.add(tf);
	      }
	    }
            else {
             SwPanel.add(new JLabel(" "));
	    }
          }

	} //for 
      optionPanel.add(SwPanel,BorderLayout.CENTER);  
      }

      if(!NameValue[0].equals("null")) {
        for(int i=0; i<NameValue.length; i++) {
          cmdLine += " "+NameValue[i];
	}  
      } 

      if(!arguments[0].equals("null")) {
        int nArguments = arguments.length;
        if(ArPanel != null) ArPanel.removeAll();
        else ArPanel = new JPanel();
        if(nArguments < 7) {
           ArPanel.setLayout(new GridLayout(nArguments,2));
	}
        else {
           ArPanel.setLayout(new GridLayout((nArguments+1)/2,4));
	}
        for(int i=0; i<nArguments; i++) {
          System.out.println(arguments[i]);
          int idx = arguments[i].indexOf("[question]");
          if(idx>-1) {
            ArPanel.add(new JCheckBox(arguments[i].substring(0,idx)));
            cmdLine += " "+arguments[i].substring(0,idx);
	  }  
	}
        argPanel.add(ArPanel,BorderLayout.CENTER);  
      }  
 
      cmdDisplay.setText(cmdLine);
      /*
      System.out.println(cmdLine.length()+" "+cmdDisplayLength);
      if(cmdLine.length() <= cmdDisplayLength) {
           cmdDisplay.setText(cmdLine);
      }
      else {
       String firstLine=cmdLine.substring(0,cmdDisplayLength);
       cmdDisplay.setText(firstLine);
       cmdLine=cmdLine.substring(cmdDisplayLength);
       while(cmdLine.length()>cmdDisplayLength) {
         cmdDisplay.append("\n"+cmdLine.substring(0,cmdDisplayLength));
         cmdLine = cmdLine.substring(cmdDisplayLength);
       }
       cmdDisplay.append("\n"+cmdLine);
      }
      */
    }
    getInputs();
  } 

  public void connect() {
    initializeORB();
    master = getMasterServer();
    if(master==null) {
      System.out.println("Cannot connect to the master server");
    }
    else {
	/* add XMLserver module */

        org.omg.CORBA.Object oxml = master.addNewModule("XmlServer");
        parser = XmlServerHelper.narrow(oxml);
        parser.test();

        /* add submitJob module */
        org.omg.CORBA.Object osj = master.addNewModule("submitJob");
        submit = submitJobHelper.narrow(osj);
        submit.test(); 
    }
  }


  public void initializeORB() { 
   Properties props = System.getProperties();
   props.put("org.omg.CORBA.ORBClass", "com.ooc.CORBA.ORB");
   props.put("org.omg.CORBA.ORBSingletonClass", "com.ooc.CORBA.ORBSingleton");
   System.setProperties(props);
   String[] args = new String[1];
   args[0]=IorURL;
   orb = ORB.init(args, props);
  }

  public WebFlowContext getMasterServer(){
    WebFlowContext ws = null;
    try {
      String masterIOR = getIORFromURL(IorURL);
      org.omg.CORBA.Object o = orb.string_to_object(masterIOR);
      
      ws = WebFlowContextHelper.narrow(o);
    }
    catch (Exception e) {System.out.println("getMasterServer: "+e);}
    return ws;
  }

  public String getIORFromURL(String urlString){
    String masterServerIOR="";
    String thisLine=null;
      try {
        URL u = new URL(urlString);
        try {
          DataInputStream theHTML = new DataInputStream(u.openStream());
          try {
            while ((thisLine = theHTML.readLine()) != null) {
		  masterServerIOR += thisLine;
            } 
          } 
          catch (Exception e) {
            System.out.println("getIORfromURL:"+e);
          }
        } 
        catch (Exception e) {
          System.out.println("getIORfromURL:"+e);
        }

      } 
      catch (MalformedURLException e) {
        System.out.println("getIORfromURL:"+urlString + " is not a parseable URL");
        System.out.println("getIORfromURL:"+e);
      }
    return masterServerIOR;
  }

  public void updateHosts(){
   // String[] hostList = null;
    hosts.removeAllElements();
    if(parser.instantiateParser(xmlFile)) {
      hostList = parser.getInstalledHosts(application);
    }
    try {
       for(int i=0; i<hostList.length; i++) {
       hosts.addElement(hostList[i]);
       }
    }
    catch (Exception e) {
        System.out.println("no installed hosts");
        hosts.addElement("not installed");
    }
    cb.setSelectedIndex(0);
    this.show();
  }


  public void getInputs() {
    inputs.removeAll();
    outputs.removeAll();
    if(parser.instantiateParser(xmlFile)) {
      String[] inputfiles = parser.getIPFiles(application,ApplHost);
      String[] outputfiles = parser.getOPFiles(application,ApplHost);
      if((inputfiles != null) && (inputfiles.length>0)) {
        int nfiles = inputfiles.length/2;
        inTab = new JPanel[nfiles];
        inTextField = new JTextField[nfiles]; 
           for(int i=0; i<(inputfiles.length); i=i+2) {
            int k = i/2;
            inTab[k] = new JPanel();
            inTab[k].setLayout(new GridLayout(2,1));
            inTab[k].add(new JLabel(inputfiles[i]+inputfiles[i+1]));
            inTextField[k]= new JTextField(30);
            inTab[k].add(inTextField[k]);
            inTab[k].setPreferredSize(new Dimension(500,50));
            inputs.addTab("input file "+i,inTab[k]);
	   }
      }
      if((outputfiles != null) && (outputfiles.length>0)) {
        int nfiles = outputfiles.length/2;
        outTab = new JPanel[nfiles];
        outTextField = new JTextField[nfiles]; 
           for(int i=0; i<(outputfiles.length); i=i+2) {
            int k = i/2;
            outTab[k] = new JPanel();
            outTab[k].setLayout(new GridLayout(2,1));
            outTab[k].add(new JLabel(outputfiles[i]+outputfiles[i+1]));
            outTextField[k]= new JTextField(30);
            outTab[k].add(outTextField[k]);
            outTab[k].setPreferredSize(new Dimension(500,50));
            outputs.addTab("output file "+i,outTab[k]);
	   }
      }
               
    }
  }

   public synchronized void waitFor(long howLong){
     try {
        wait(howLong);
     } catch (Exception e) { System.out.println(e);}
   }

  public void checkBoxChange(int i, String what) {
    if(i==ItemEvent.DESELECTED) {
       String copy = cmdDisplay.getText();
       int idx = copy.indexOf(what);
       String newText = copy.substring(0,idx-1);
       newText += copy.substring(idx+what.length());
       cmdDisplay.setText(newText);
    }
    if(i==ItemEvent.SELECTED) {
      cmdDisplay.append(" "+what);
   }
  }
 
}


