import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;

public class WebFlowServerPanel extends JPanel {

String[] conf; 
String[] params;
JTextField[] s;
ActionListener[] al;
JPanel[] pp;
int n;
String WebFlowServerFileName;
desktop d;
String selectedServer;

  public WebFlowServerPanel(desktop d, String selectedServer) {

  this.d = d;
  this.selectedServer = selectedServer;
  n = d.n_WF;
  
  conf = new String[n];
  for(int i=0;i<n;i++) {
     conf[i]="";
  }
  s = new JTextField[n];
  params = new String[n];
  params[0]=" Master WebFlow Server Host ";
  params[1]="     relative IOR directory ";
  params[2]="       Master IOR file name ";
  params[3]="       Master IOR URL       "; 
  params[4]=" relative WF conf directory ";
  params[5]=" Master configuration file  ";

  pp = new JPanel[n];
  al = new ActionListener[n];
  
  WebFlowServerFileName = selectedServer+"WF.conf";

  conf[0] = selectedServer;
  conf[1] = "IOR";
  conf[2] = "master.txt";
  conf[3] = "http://"+d.WS_host+":"+d.WS_port+"/"+conf[1]+"/"+conf[2];
  conf[4] = d.WS_docroot+"/"+"WFconf";
  conf[5] = "QSmaster.conf";

  File conffile = new File(WebFlowServerFileName);
  if(conffile.exists()) {
    try {
      FileReader fr = new FileReader(conffile);
      BufferedReader in = new BufferedReader(fr);
      String nextline = in.readLine();
      in.close();
      StringTokenizer st = new StringTokenizer(nextline,"+");
      for(int i=0; i<n; i++) {
        conf[i] = st.nextToken();
      }
      d.setWFConfig(conf);
   }
    catch (Exception e) {System.out.println(e);}
  }  
  else {
    System.out.println("new configuration");
  }


  setLayout(new BorderLayout());

  JPanel ss = new JPanel();
  ss.setLayout(new GridLayout(n,1));


     al[0] = new ActionListener() {
        public void actionPerformed(ActionEvent e) {
        setWFconf(0,e.getActionCommand());
     }
     };

     al[1] = new ActionListener() {
        public void actionPerformed(ActionEvent e) {
        setWFconf(1,e.getActionCommand());
     }
     };
     al[2] = new ActionListener() {
        public void actionPerformed(ActionEvent e) {
        setWFconf(2,e.getActionCommand());
     }
     };
     al[3] = new ActionListener() {
        public void actionPerformed(ActionEvent e) {
        setWFconf(3,e.getActionCommand());
     }
     };
     al[4] = new ActionListener() {
        public void actionPerformed(ActionEvent e) {
        setWFconf(4,e.getActionCommand());
     }
     };
     al[5] = new ActionListener() {
        public void actionPerformed(ActionEvent e) {
        setWFconf(5,e.getActionCommand());
     }
     };
  if(n>6) {
     System.out.println("not enough action listeners in WebFlowServerPanel");
     System.exit(0);
  }
   
  JLabel l;
  for (int i = 0; i<n; i++) {
     pp[i] = new JPanel();
     pp[i].setLayout(new BorderLayout());
     l = new JLabel(params[i]);
     l.setFont(new Font("Courier", Font.BOLD, 12));
     l.setForeground(Color.black);
     pp[i].add(l,BorderLayout.WEST);
     s[i] = new JTextField(conf[i],25);
     s[i].setPreferredSize(new Dimension(100,5));
     s[i].addActionListener(al[i]);
     pp[i].add(s[i],BorderLayout.CENTER);
     ss.add(pp[i]);  
  }
  
  add(ss,BorderLayout.CENTER);
  
  JPanel bp = new JPanel();
  bp.setLayout(new GridLayout(1,2));
  JButton b1 = new JButton("Commit");
  b1.addActionListener(new ActionListener() {
    public void actionPerformed(ActionEvent e) {
       commit();
    }
  });
  bp.add(b1);

  JButton b2 = new JButton("Reset");
  b2.addActionListener(new ActionListener() {
    public void actionPerformed(ActionEvent e) {
       reset();
    }
  });
  bp.add(b2);
  add(bp,BorderLayout.SOUTH);
  }


  public void setWFconf(int i, String h) {
     conf[i]=h;
  } 

  public void commit() {
     d.setWFConfig(conf);
     try {    
        FileWriter fw = new FileWriter(WebFlowServerFileName);
        for (int i=0;i<n;i++) {
          if(conf[i].length()<1) fw.write("null+"); 
          else fw.write(conf[i]+"+");
        }
        fw.flush();
        fw.close();
     }
     catch (Exception e) { System.out.println(e);}
  }

  public void reset() {
    for(int i=0;i<n;i++) {
     conf[i]="";
     s[i].setText("");
    }
  }

}
